import numpy as np
from scipy.stats import stats
from tqdm import tqdm


def analyze_scores(scores, confidence=0.95, output=True):
    # theres going to be a better way to do this - too bad!
    if isinstance(scores[0], list):
        # Flatten List if k-fold results
        scores = [score_ for sublist in scores for score_ in sublist]
    tqdm.write(str(scores))
    tqdm.write(str(len(scores)))
    scores_dict = {}
    for k in scores[0][0].keys():
        scores_dict[k] = [score[k] for sublist in scores for score in sublist]

    # Now calculate mean, standard deviation and conf for each metric
    analyzed_scores = {}
    for metric, values in scores_dict.items():
        mean = np.mean(values)
        stdev = np.std(values)
        conf = stats.t.interval(confidence, len(values)-1, loc=mean, scale=stdev)
        analyzed_scores[metric] = {
            'mean': mean,
            'stdev': stdev,
            'conf': conf
        }
    if output:
        print(analyzed_scores)

    return analyzed_scores

