from string_utils import build_model_name
import os
from pydrive.auth import GoogleAuth
from pydrive.drive import GoogleDrive


def save_to_google_drive(model, drive=None, local_save_path=None, is_best=True, save_folder="Models/"):
    if drive is None:
        gauth = GoogleAuth()
        gauth.LocalWebserverAuth()  # client_secrets.json need to be in the same directory as the script
        drive = GoogleDrive(gauth)
    model_name = build_model_name(model)
    if local_save_path is None:
        if is_best:
            local_save_path = os.path.join(save_folder, f'{model_name}_best.pt')
        else:
            local_save_path = os.path.join(save_folder, f'{model_name}_last.pt')
    model_name_with_time = build_model_name(model, add_time_to_model_name=True)
    file_name_of_upload = f'{model_name_with_time}_{"best" if is_best else "last"}.pt'
    print(f"Uploading: {file_name_of_upload}")
    file = drive.CreateFile({'title': file_name_of_upload})
    file.SetContentFile(local_save_path)
    file.Upload()